
<!DOCTYPE html>
<html>
<head>
  <title>Promises test</title>
  <link rel="stylesheet" href="css/styles.css">
</head>
<body>
  <div class="network-fake">
    <label><input type="checkbox"> Fake network delay</label>
  </div>
  <div class="story"></div>
  <svg class="spinner" viewBox="0 0 100 100" width="20" height="20">
    <circle cx="50" cy="50" r="42" transform="rotate(-90,50,50)" />
  </svg>

  <script src="js/promise-2.0.4.min.js"></script>
  <script src="js/utils.js"></script>
  <script>
    // Use Github Gist when no web server is available
    // getJson('https://gist.githubusercontent.com/c0lin/571d38b984d41b44aacf/raw/story.json').then(function(story) {
    getJson('data/story.json')
    // TODO 2
    .then(function(story) {
      let promise = new Promise(function(resolve, reject) {
        let response = confirm("Keep promise?");
        if (response) {
          resolve(story);
        } else {
          reject(Error("You didn't keep the promise."));
        }
      });
      return promise;
    })
    .then(function(story) {
      addHtmlToPage(story.heading);

      // Update the URLs for next fetch
      var chapterUrls = story.chapterUrls;
      chapterUrls = chapterUrls.map(function(url){ return "data/"+url; });
      
      // Take an array of promises and wait on them all
      return Promise.all(
        // Map our array of chapter urls
        // to an array of chapter json promises
        chapterUrls.map(getJson)
      );
    })


    .then(function(chapters) {
      // Now we have the chapters jsons in order! Loop thorugh...
      chapters.forEach(function(chapter) {
        // ..and add to the page
        addHtmlToPage(chapter.html);
      });
      addTextToPage("All done");
    })

    .catch(function(err) {
      // catch any error that happened along the way
      addTextToPage("Argh, broken: " + err.message);
    })

    .then(function() {
      document.querySelector('.spinner').style.display = 'none';
    });
  </script>
</body>
</html>